/*!
 * devextreme-angular
 * Version: 23.2.6-build-24091-0113
 * Build date: Sun Mar 31 2024
 *
 * Copyright (c) 2012 - 2024 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { TemplateRef, ViewContainerRef, Renderer2, NgZone } from '@angular/core';
import { DxTemplateHost } from './template-host';
import * as i0 from "@angular/core";
export declare const DX_TEMPLATE_WRAPPER_CLASS = "dx-template-wrapper";
export declare class RenderData {
    model: any;
    index: number;
    container: any;
}
export declare class DxTemplateDirective {
    private readonly templateRef;
    private readonly viewContainerRef;
    private readonly renderer;
    private readonly zone;
    set dxTemplateOf(value: any);
    name: string;
    constructor(templateRef: TemplateRef<any>, viewContainerRef: ViewContainerRef, templateHost: DxTemplateHost, renderer: Renderer2, zone: NgZone);
    private renderTemplate;
    render(renderData: RenderData): any;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxTemplateDirective, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<DxTemplateDirective, "[dxTemplate]", never, { "dxTemplateOf": "dxTemplateOf"; }, {}, never>;
}
export declare class DxTemplateModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxTemplateModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxTemplateModule, [typeof DxTemplateDirective], never, [typeof DxTemplateDirective]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxTemplateModule>;
}
