/*!
 * devextreme-angular
 * Version: 23.2.6-build-24091-0113
 * Build date: Sun Mar 31 2024
 *
 * Copyright (c) 2012 - 2024 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { OnInit, OnDestroy } from '@angular/core';
import { BackgroundImageLocation } from 'devextreme/viz/range_selector';
import { NestedOptionHost } from 'devextreme-angular/core';
import { NestedOption } from 'devextreme-angular/core';
import * as i0 from "@angular/core";
export declare class DxoBackgroundComponent extends NestedOption implements OnDestroy, OnInit {
    get color(): string;
    set color(value: string);
    get image(): {
        location?: BackgroundImageLocation;
        url?: string | undefined;
    };
    set image(value: {
        location?: BackgroundImageLocation;
        url?: string | undefined;
    });
    get visible(): boolean;
    set visible(value: boolean);
    get borderColor(): string;
    set borderColor(value: string);
    protected get _optionPath(): string;
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoBackgroundComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoBackgroundComponent, "dxo-background", never, { "color": "color"; "image": "image"; "visible": "visible"; "borderColor": "borderColor"; }, {}, never, never>;
}
export declare class DxoBackgroundModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoBackgroundModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoBackgroundModule, [typeof DxoBackgroundComponent], never, [typeof DxoBackgroundComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoBackgroundModule>;
}
