/*!
 * devextreme-angular
 * Version: 23.2.6-build-24091-0113
 * Build date: Sun Mar 31 2024
 *
 * Copyright (c) 2012 - 2024 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { NestedOption } from 'devextreme-angular/core';
import { CollisionResolution, CollisionResolutionCombination } from 'devextreme/animation/position';
import { HorizontalAlignment, PositionAlignment, VerticalAlignment } from 'devextreme/common';
import { UserDefinedElement } from 'devextreme/core/element';
import * as i0 from "@angular/core";
export declare abstract class DxoPositionConfig extends NestedOption {
    get at(): PositionAlignment | {
        x?: HorizontalAlignment;
        y?: VerticalAlignment;
    };
    set at(value: PositionAlignment | {
        x?: HorizontalAlignment;
        y?: VerticalAlignment;
    });
    get boundary(): string | UserDefinedElement | Window;
    set boundary(value: string | UserDefinedElement | Window);
    get boundaryOffset(): string | {
        x?: number;
        y?: number;
    };
    set boundaryOffset(value: string | {
        x?: number;
        y?: number;
    });
    get collision(): CollisionResolutionCombination | {
        x?: CollisionResolution;
        y?: CollisionResolution;
    };
    set collision(value: CollisionResolutionCombination | {
        x?: CollisionResolution;
        y?: CollisionResolution;
    });
    get my(): PositionAlignment | {
        x?: HorizontalAlignment;
        y?: VerticalAlignment;
    };
    set my(value: PositionAlignment | {
        x?: HorizontalAlignment;
        y?: VerticalAlignment;
    });
    get of(): string | UserDefinedElement | Window;
    set of(value: string | UserDefinedElement | Window);
    get offset(): string | {
        x?: number;
        y?: number;
    };
    set offset(value: string | {
        x?: number;
        y?: number;
    });
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoPositionConfig, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoPositionConfig, "ng-component", never, {}, {}, never, never>;
}
