/*!
 * devextreme-angular
 * Version: 23.2.6-build-24091-0113
 * Build date: Sun Mar 31 2024
 *
 * Copyright (c) 2012 - 2024 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { CollectionNestedOption } from 'devextreme-angular/core';
import { TextEditorButtonLocation } from 'devextreme/common';
import { dxButtonOptions } from 'devextreme/ui/button';
import { ColumnButtonClickEvent, DataGridPredefinedColumnButton } from 'devextreme/ui/data_grid';
import { TreeListPredefinedColumnButton } from 'devextreme/ui/tree_list';
import * as i0 from "@angular/core";
export declare abstract class DxiTextEditorButton extends CollectionNestedOption {
    get location(): TextEditorButtonLocation;
    set location(value: TextEditorButtonLocation);
    get name(): string | undefined | DataGridPredefinedColumnButton | TreeListPredefinedColumnButton;
    set name(value: string | undefined | DataGridPredefinedColumnButton | TreeListPredefinedColumnButton);
    get options(): dxButtonOptions | undefined;
    set options(value: dxButtonOptions | undefined);
    get cssClass(): string;
    set cssClass(value: string);
    get disabled(): boolean | Function;
    set disabled(value: boolean | Function);
    get hint(): string;
    set hint(value: string);
    get icon(): string;
    set icon(value: string);
    get onClick(): ((e: ColumnButtonClickEvent) => void);
    set onClick(value: ((e: ColumnButtonClickEvent) => void));
    get template(): any;
    set template(value: any);
    get text(): string;
    set text(value: string);
    get visible(): boolean | Function;
    set visible(value: boolean | Function);
    static ɵfac: i0.ɵɵFactoryDeclaration<DxiTextEditorButton, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxiTextEditorButton, "ng-component", never, {}, {}, never, never>;
}
