/*!
 * devextreme-angular
 * Version: 23.2.6-build-24091-0113
 * Build date: Sun Mar 31 2024
 *
 * Copyright (c) 2012 - 2024 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { OnInit, OnDestroy, EventEmitter } from '@angular/core';
import { CalendarZoomLevel } from 'devextreme/ui/calendar';
import { NestedOptionHost } from 'devextreme-angular/core';
import { DxoCalendarOptions } from './base/calendar-options';
import * as i0 from "@angular/core";
export declare class DxoCalendarOptionsComponent extends DxoCalendarOptions implements OnDestroy, OnInit {
    /**
    
     * This member supports the internal infrastructure and is not intended to be used directly from your code.
    
     */
    valueChange: EventEmitter<Date | number | string | Array<Date | number | string>>;
    /**
    
     * This member supports the internal infrastructure and is not intended to be used directly from your code.
    
     */
    zoomLevelChange: EventEmitter<CalendarZoomLevel>;
    protected get _optionPath(): string;
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoCalendarOptionsComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoCalendarOptionsComponent, "dxo-calendar-options", never, { "accessKey": "accessKey"; "activeStateEnabled": "activeStateEnabled"; "cellTemplate": "cellTemplate"; "dateSerializationFormat": "dateSerializationFormat"; "disabled": "disabled"; "disabledDates": "disabledDates"; "elementAttr": "elementAttr"; "firstDayOfWeek": "firstDayOfWeek"; "focusStateEnabled": "focusStateEnabled"; "height": "height"; "hint": "hint"; "hoverStateEnabled": "hoverStateEnabled"; "isDirty": "isDirty"; "isValid": "isValid"; "max": "max"; "maxZoomLevel": "maxZoomLevel"; "min": "min"; "minZoomLevel": "minZoomLevel"; "name": "name"; "onDisposing": "onDisposing"; "onInitialized": "onInitialized"; "onOptionChanged": "onOptionChanged"; "onValueChanged": "onValueChanged"; "readOnly": "readOnly"; "rtlEnabled": "rtlEnabled"; "selectionMode": "selectionMode"; "selectWeekOnClick": "selectWeekOnClick"; "showTodayButton": "showTodayButton"; "showWeekNumbers": "showWeekNumbers"; "tabIndex": "tabIndex"; "validationError": "validationError"; "validationErrors": "validationErrors"; "validationMessageMode": "validationMessageMode"; "validationMessagePosition": "validationMessagePosition"; "validationStatus": "validationStatus"; "value": "value"; "visible": "visible"; "weekNumberRule": "weekNumberRule"; "width": "width"; "zoomLevel": "zoomLevel"; }, { "valueChange": "valueChange"; "zoomLevelChange": "zoomLevelChange"; }, never, never>;
}
export declare class DxoCalendarOptionsModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoCalendarOptionsModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoCalendarOptionsModule, [typeof DxoCalendarOptionsComponent], never, [typeof DxoCalendarOptionsComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoCalendarOptionsModule>;
}
