/*!
 * devextreme-angular
 * Version: 23.2.6-build-24091-0113
 * Build date: Sun Mar 31 2024
 *
 * Copyright (c) 2012 - 2024 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { OnInit, OnDestroy } from '@angular/core';
import { Palette, PaletteExtensionMode } from 'devextreme/common/charts';
import { TreeMapColorizerType } from 'devextreme/viz/tree_map';
import { NestedOptionHost } from 'devextreme-angular/core';
import { NestedOption } from 'devextreme-angular/core';
import * as i0 from "@angular/core";
export declare class DxoColorizerComponent extends NestedOption implements OnDestroy, OnInit {
    get colorCodeField(): string | undefined;
    set colorCodeField(value: string | undefined);
    get colorizeGroups(): boolean;
    set colorizeGroups(value: boolean);
    get palette(): Palette | string | Array<string>;
    set palette(value: Palette | string | Array<string>);
    get paletteExtensionMode(): PaletteExtensionMode;
    set paletteExtensionMode(value: PaletteExtensionMode);
    get range(): Array<number>;
    set range(value: Array<number>);
    get type(): TreeMapColorizerType | undefined;
    set type(value: TreeMapColorizerType | undefined);
    protected get _optionPath(): string;
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoColorizerComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoColorizerComponent, "dxo-colorizer", never, { "colorCodeField": "colorCodeField"; "colorizeGroups": "colorizeGroups"; "palette": "palette"; "paletteExtensionMode": "paletteExtensionMode"; "range": "range"; "type": "type"; }, {}, never, never>;
}
export declare class DxoColorizerModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoColorizerModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoColorizerModule, [typeof DxoColorizerComponent], never, [typeof DxoColorizerComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoColorizerModule>;
}
