/*!
 * devextreme-angular
 * Version: 23.2.6-build-24091-0113
 * Build date: Sun Mar 31 2024
 *
 * Copyright (c) 2012 - 2024 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { OnInit, OnDestroy } from '@angular/core';
import DevExpress from 'devextreme/bundles/dx.all';
import { DashStyle } from 'devextreme/common/charts';
import { NestedOptionHost } from 'devextreme-angular/core';
import { NestedOption } from 'devextreme-angular/core';
import * as i0 from "@angular/core";
export declare class DxoCommonPaneSettingsComponent extends NestedOption implements OnDestroy, OnInit {
    get backgroundColor(): DevExpress.common.charts.ChartsColor | string;
    set backgroundColor(value: DevExpress.common.charts.ChartsColor | string);
    get border(): {
        bottom?: boolean;
        color?: string;
        dashStyle?: DashStyle;
        left?: boolean;
        opacity?: number | undefined;
        right?: boolean;
        top?: boolean;
        visible?: boolean;
        width?: number;
    };
    set border(value: {
        bottom?: boolean;
        color?: string;
        dashStyle?: DashStyle;
        left?: boolean;
        opacity?: number | undefined;
        right?: boolean;
        top?: boolean;
        visible?: boolean;
        width?: number;
    });
    protected get _optionPath(): string;
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoCommonPaneSettingsComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoCommonPaneSettingsComponent, "dxo-common-pane-settings", never, { "backgroundColor": "backgroundColor"; "border": "border"; }, {}, never, never>;
}
export declare class DxoCommonPaneSettingsModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoCommonPaneSettingsModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoCommonPaneSettingsModule, [typeof DxoCommonPaneSettingsComponent], never, [typeof DxoCommonPaneSettingsComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoCommonPaneSettingsModule>;
}
