/*!
 * devextreme-angular
 * Version: 23.2.6-build-24091-0113
 * Build date: Sun Mar 31 2024
 *
 * Copyright (c) 2012 - 2024 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { OnInit, OnDestroy, QueryList } from '@angular/core';
import { NestedOptionHost } from 'devextreme-angular/core';
import { DxoPivotGridDataSource } from './base/pivot-grid-data-source';
import { DxiFieldComponent } from './field-dxi';
import * as i0 from "@angular/core";
export declare class DxoDataSourceComponent extends DxoPivotGridDataSource implements OnDestroy, OnInit {
    protected get _optionPath(): string;
    get fieldsChildren(): QueryList<DxiFieldComponent>;
    set fieldsChildren(value: QueryList<DxiFieldComponent>);
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoDataSourceComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoDataSourceComponent, "dxo-data-source", never, { "fields": "fields"; "filter": "filter"; "onChanged": "onChanged"; "onFieldsPrepared": "onFieldsPrepared"; "onLoadError": "onLoadError"; "onLoadingChanged": "onLoadingChanged"; "remoteOperations": "remoteOperations"; "retrieveFields": "retrieveFields"; "store": "store"; }, {}, ["fieldsChildren"], never>;
}
export declare class DxoDataSourceModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoDataSourceModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoDataSourceModule, [typeof DxoDataSourceComponent], never, [typeof DxoDataSourceComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoDataSourceModule>;
}
