/*!
 * devextreme-angular
 * Version: 23.2.6-build-24091-0113
 * Build date: Sun Mar 31 2024
 *
 * Copyright (c) 2012 - 2024 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { OnInit, OnDestroy } from '@angular/core';
import { Store } from 'devextreme/data';
import DataSource, { Options as DataSourceOptions } from 'devextreme/data/data_source';
import { NestedOptionHost } from 'devextreme-angular/core';
import { NestedOption } from 'devextreme-angular/core';
import * as i0 from "@angular/core";
export declare class DxoEdgesComponent extends NestedOption implements OnDestroy, OnInit {
    get customDataExpr(): Function | string | undefined;
    set customDataExpr(value: Function | string | undefined);
    get dataSource(): DataSource | DataSourceOptions | Store | null | string | Array<any>;
    set dataSource(value: DataSource | DataSourceOptions | Store | null | string | Array<any>);
    get fromExpr(): Function | string;
    set fromExpr(value: Function | string);
    get fromLineEndExpr(): Function | string | undefined;
    set fromLineEndExpr(value: Function | string | undefined);
    get fromPointIndexExpr(): Function | string | undefined;
    set fromPointIndexExpr(value: Function | string | undefined);
    get keyExpr(): Function | string;
    set keyExpr(value: Function | string);
    get lineTypeExpr(): Function | string | undefined;
    set lineTypeExpr(value: Function | string | undefined);
    get lockedExpr(): Function | string | undefined;
    set lockedExpr(value: Function | string | undefined);
    get pointsExpr(): Function | string | undefined;
    set pointsExpr(value: Function | string | undefined);
    get styleExpr(): Function | string | undefined;
    set styleExpr(value: Function | string | undefined);
    get textExpr(): Function | string | undefined;
    set textExpr(value: Function | string | undefined);
    get textStyleExpr(): Function | string | undefined;
    set textStyleExpr(value: Function | string | undefined);
    get toExpr(): Function | string;
    set toExpr(value: Function | string);
    get toLineEndExpr(): Function | string | undefined;
    set toLineEndExpr(value: Function | string | undefined);
    get toPointIndexExpr(): Function | string | undefined;
    set toPointIndexExpr(value: Function | string | undefined);
    get zIndexExpr(): Function | string | undefined;
    set zIndexExpr(value: Function | string | undefined);
    protected get _optionPath(): string;
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoEdgesComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoEdgesComponent, "dxo-edges", never, { "customDataExpr": "customDataExpr"; "dataSource": "dataSource"; "fromExpr": "fromExpr"; "fromLineEndExpr": "fromLineEndExpr"; "fromPointIndexExpr": "fromPointIndexExpr"; "keyExpr": "keyExpr"; "lineTypeExpr": "lineTypeExpr"; "lockedExpr": "lockedExpr"; "pointsExpr": "pointsExpr"; "styleExpr": "styleExpr"; "textExpr": "textExpr"; "textStyleExpr": "textStyleExpr"; "toExpr": "toExpr"; "toLineEndExpr": "toLineEndExpr"; "toPointIndexExpr": "toPointIndexExpr"; "zIndexExpr": "zIndexExpr"; }, {}, never, never>;
}
export declare class DxoEdgesModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoEdgesModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoEdgesModule, [typeof DxoEdgesComponent], never, [typeof DxoEdgesComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoEdgesModule>;
}
