/*!
 * devextreme-angular
 * Version: 23.2.6-build-24091-0113
 * Build date: Sun Mar 31 2024
 *
 * Copyright (c) 2012 - 2024 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { OnInit, OnDestroy } from '@angular/core';
import { FieldChooserLayout } from 'devextreme/common';
import { ApplyChangesMode } from 'devextreme/common/grids';
import { NestedOptionHost } from 'devextreme-angular/core';
import { NestedOption } from 'devextreme-angular/core';
import * as i0 from "@angular/core";
export declare class DxoFieldChooserComponent extends NestedOption implements OnDestroy, OnInit {
    get allowSearch(): boolean;
    set allowSearch(value: boolean);
    get applyChangesMode(): ApplyChangesMode;
    set applyChangesMode(value: ApplyChangesMode);
    get enabled(): boolean;
    set enabled(value: boolean);
    get height(): number;
    set height(value: number);
    get layout(): FieldChooserLayout;
    set layout(value: FieldChooserLayout);
    get searchTimeout(): number;
    set searchTimeout(value: number);
    get texts(): {
        allFields?: string;
        columnFields?: string;
        dataFields?: string;
        filterFields?: string;
        rowFields?: string;
    };
    set texts(value: {
        allFields?: string;
        columnFields?: string;
        dataFields?: string;
        filterFields?: string;
        rowFields?: string;
    });
    get title(): string;
    set title(value: string);
    get width(): number;
    set width(value: number);
    protected get _optionPath(): string;
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoFieldChooserComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoFieldChooserComponent, "dxo-field-chooser", never, { "allowSearch": "allowSearch"; "applyChangesMode": "applyChangesMode"; "enabled": "enabled"; "height": "height"; "layout": "layout"; "searchTimeout": "searchTimeout"; "texts": "texts"; "title": "title"; "width": "width"; }, {}, never, never>;
}
export declare class DxoFieldChooserModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoFieldChooserModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoFieldChooserModule, [typeof DxoFieldChooserComponent], never, [typeof DxoFieldChooserComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoFieldChooserModule>;
}
