/*!
 * devextreme-angular
 * Version: 23.2.6-build-24091-0113
 * Build date: Sun Mar 31 2024
 *
 * Copyright (c) 2012 - 2024 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { OnInit, OnDestroy, EventEmitter, QueryList } from '@angular/core';
import DevExpress from 'devextreme/bundles/dx.all';
import { PositionAlignment } from 'devextreme/common';
import { NestedOptionHost } from 'devextreme-angular/core';
import { DxoPopupOptions } from './base/popup-options';
import { DxiToolbarItemComponent } from './toolbar-item-dxi';
import * as i0 from "@angular/core";
export declare class DxoFilterBuilderPopupComponent extends DxoPopupOptions implements OnDestroy, OnInit {
    /**
    
     * This member supports the internal infrastructure and is not intended to be used directly from your code.
    
     */
    heightChange: EventEmitter<number | Function | string>;
    /**
    
     * This member supports the internal infrastructure and is not intended to be used directly from your code.
    
     */
    positionChange: EventEmitter<PositionAlignment | DevExpress.PositionConfig | Function>;
    /**
    
     * This member supports the internal infrastructure and is not intended to be used directly from your code.
    
     */
    visibleChange: EventEmitter<boolean>;
    /**
    
     * This member supports the internal infrastructure and is not intended to be used directly from your code.
    
     */
    widthChange: EventEmitter<number | Function | string>;
    protected get _optionPath(): string;
    get toolbarItemsChildren(): QueryList<DxiToolbarItemComponent>;
    set toolbarItemsChildren(value: QueryList<DxiToolbarItemComponent>);
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoFilterBuilderPopupComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoFilterBuilderPopupComponent, "dxo-filter-builder-popup", never, { "accessKey": "accessKey"; "animation": "animation"; "closeOnOutsideClick": "closeOnOutsideClick"; "container": "container"; "contentTemplate": "contentTemplate"; "copyRootClassesToWrapper": "copyRootClassesToWrapper"; "deferRendering": "deferRendering"; "disabled": "disabled"; "dragAndResizeArea": "dragAndResizeArea"; "dragEnabled": "dragEnabled"; "dragOutsideBoundary": "dragOutsideBoundary"; "elementAttr": "elementAttr"; "enableBodyScroll": "enableBodyScroll"; "focusStateEnabled": "focusStateEnabled"; "fullScreen": "fullScreen"; "height": "height"; "hideOnOutsideClick": "hideOnOutsideClick"; "hideOnParentScroll": "hideOnParentScroll"; "hint": "hint"; "hoverStateEnabled": "hoverStateEnabled"; "maxHeight": "maxHeight"; "maxWidth": "maxWidth"; "minHeight": "minHeight"; "minWidth": "minWidth"; "onContentReady": "onContentReady"; "onDisposing": "onDisposing"; "onHidden": "onHidden"; "onHiding": "onHiding"; "onInitialized": "onInitialized"; "onOptionChanged": "onOptionChanged"; "onResize": "onResize"; "onResizeEnd": "onResizeEnd"; "onResizeStart": "onResizeStart"; "onShowing": "onShowing"; "onShown": "onShown"; "onTitleRendered": "onTitleRendered"; "position": "position"; "resizeEnabled": "resizeEnabled"; "restorePosition": "restorePosition"; "rtlEnabled": "rtlEnabled"; "shading": "shading"; "shadingColor": "shadingColor"; "showCloseButton": "showCloseButton"; "showTitle": "showTitle"; "tabIndex": "tabIndex"; "title": "title"; "titleTemplate": "titleTemplate"; "toolbarItems": "toolbarItems"; "visible": "visible"; "width": "width"; "wrapperAttr": "wrapperAttr"; }, { "heightChange": "heightChange"; "positionChange": "positionChange"; "visibleChange": "visibleChange"; "widthChange": "widthChange"; }, ["toolbarItemsChildren"], never>;
}
export declare class DxoFilterBuilderPopupModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoFilterBuilderPopupModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoFilterBuilderPopupModule, [typeof DxoFilterBuilderPopupComponent], never, [typeof DxoFilterBuilderPopupComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoFilterBuilderPopupModule>;
}
