/*!
 * devextreme-angular
 * Version: 23.2.6-build-24091-0113
 * Build date: Sun Mar 31 2024
 *
 * Copyright (c) 2012 - 2024 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { OnInit, OnDestroy, EventEmitter, QueryList } from '@angular/core';
import { NestedOptionHost } from 'devextreme-angular/core';
import { DxoFilterBuilderOptions } from './base/filter-builder-options';
import { DxiCustomOperationComponent } from './custom-operation-dxi';
import { DxiFieldComponent } from './field-dxi';
import * as i0 from "@angular/core";
export declare class DxoFilterBuilderComponent extends DxoFilterBuilderOptions implements OnDestroy, OnInit {
    /**
    
     * This member supports the internal infrastructure and is not intended to be used directly from your code.
    
     */
    valueChange: EventEmitter<any>;
    protected get _optionPath(): string;
    get customOperationsChildren(): QueryList<DxiCustomOperationComponent>;
    set customOperationsChildren(value: QueryList<DxiCustomOperationComponent>);
    get fieldsChildren(): QueryList<DxiFieldComponent>;
    set fieldsChildren(value: QueryList<DxiFieldComponent>);
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoFilterBuilderComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoFilterBuilderComponent, "dxo-filter-builder", never, { "accessKey": "accessKey"; "activeStateEnabled": "activeStateEnabled"; "allowHierarchicalFields": "allowHierarchicalFields"; "customOperations": "customOperations"; "disabled": "disabled"; "elementAttr": "elementAttr"; "fields": "fields"; "filterOperationDescriptions": "filterOperationDescriptions"; "focusStateEnabled": "focusStateEnabled"; "groupOperationDescriptions": "groupOperationDescriptions"; "groupOperations": "groupOperations"; "height": "height"; "hint": "hint"; "hoverStateEnabled": "hoverStateEnabled"; "maxGroupLevel": "maxGroupLevel"; "onContentReady": "onContentReady"; "onDisposing": "onDisposing"; "onEditorPrepared": "onEditorPrepared"; "onEditorPreparing": "onEditorPreparing"; "onInitialized": "onInitialized"; "onOptionChanged": "onOptionChanged"; "onValueChanged": "onValueChanged"; "rtlEnabled": "rtlEnabled"; "tabIndex": "tabIndex"; "value": "value"; "visible": "visible"; "width": "width"; }, { "valueChange": "valueChange"; }, ["customOperationsChildren", "fieldsChildren"], never>;
}
export declare class DxoFilterBuilderModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoFilterBuilderModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoFilterBuilderModule, [typeof DxoFilterBuilderComponent], never, [typeof DxoFilterBuilderComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoFilterBuilderModule>;
}
