/*!
 * devextreme-angular
 * Version: 23.2.6-build-24091-0113
 * Build date: Sun Mar 31 2024
 *
 * Copyright (c) 2012 - 2024 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { OnInit, OnDestroy, EventEmitter } from '@angular/core';
import { NestedOptionHost } from 'devextreme-angular/core';
import { NestedOption } from 'devextreme-angular/core';
import * as i0 from "@angular/core";
export declare class DxoFilterPanelComponent extends NestedOption implements OnDestroy, OnInit {
    get customizeText(): Function;
    set customizeText(value: Function);
    get filterEnabled(): boolean;
    set filterEnabled(value: boolean);
    get texts(): {
        clearFilter?: string;
        createFilter?: string;
        filterEnabledHint?: string;
    };
    set texts(value: {
        clearFilter?: string;
        createFilter?: string;
        filterEnabledHint?: string;
    });
    get visible(): boolean;
    set visible(value: boolean);
    /**
    
     * This member supports the internal infrastructure and is not intended to be used directly from your code.
    
     */
    filterEnabledChange: EventEmitter<boolean>;
    protected get _optionPath(): string;
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoFilterPanelComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoFilterPanelComponent, "dxo-filter-panel", never, { "customizeText": "customizeText"; "filterEnabled": "filterEnabled"; "texts": "texts"; "visible": "visible"; }, { "filterEnabledChange": "filterEnabledChange"; }, never, never>;
}
export declare class DxoFilterPanelModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoFilterPanelModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoFilterPanelModule, [typeof DxoFilterPanelComponent], never, [typeof DxoFilterPanelComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoFilterPanelModule>;
}
