/*!
 * devextreme-angular
 * Version: 23.2.6-build-24091-0113
 * Build date: Sun Mar 31 2024
 *
 * Copyright (c) 2012 - 2024 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { OnInit, OnDestroy, QueryList } from '@angular/core';
import { NestedOptionHost } from 'devextreme-angular/core';
import { DxoFormSimpleItem } from './base/form-simple-item';
import { DxiValidationRuleComponent } from './validation-rule-dxi';
import * as i0 from "@angular/core";
export declare class DxoFormItemComponent extends DxoFormSimpleItem implements OnDestroy, OnInit {
    protected get _optionPath(): string;
    get validationRulesChildren(): QueryList<DxiValidationRuleComponent>;
    set validationRulesChildren(value: QueryList<DxiValidationRuleComponent>);
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoFormItemComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoFormItemComponent, "dxo-form-item", never, { "colSpan": "colSpan"; "cssClass": "cssClass"; "dataField": "dataField"; "editorOptions": "editorOptions"; "editorType": "editorType"; "helpText": "helpText"; "isRequired": "isRequired"; "itemType": "itemType"; "label": "label"; "name": "name"; "template": "template"; "validationRules": "validationRules"; "visible": "visible"; "visibleIndex": "visibleIndex"; }, {}, ["validationRulesChildren"], never>;
}
export declare class DxoFormItemModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoFormItemModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoFormItemModule, [typeof DxoFormItemComponent], never, [typeof DxoFormItemComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoFormItemModule>;
}
