/*!
 * devextreme-angular
 * Version: 23.2.6-build-24091-0113
 * Build date: Sun Mar 31 2024
 *
 * Copyright (c) 2012 - 2024 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { OnInit, OnDestroy, EventEmitter, QueryList } from '@angular/core';
import { NestedOptionHost } from 'devextreme-angular/core';
import { DxoFormOptions } from './base/form-options';
import { DxiItemComponent } from './item-dxi';
import * as i0 from "@angular/core";
export declare class DxoFormComponent extends DxoFormOptions implements OnDestroy, OnInit {
    /**
    
     * This member supports the internal infrastructure and is not intended to be used directly from your code.
    
     */
    formDataChange: EventEmitter<any>;
    protected get _optionPath(): string;
    get itemsChildren(): QueryList<DxiItemComponent>;
    set itemsChildren(value: QueryList<DxiItemComponent>);
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoFormComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoFormComponent, "dxo-form", never, { "accessKey": "accessKey"; "activeStateEnabled": "activeStateEnabled"; "alignItemLabels": "alignItemLabels"; "alignItemLabelsInAllGroups": "alignItemLabelsInAllGroups"; "colCount": "colCount"; "colCountByScreen": "colCountByScreen"; "customizeItem": "customizeItem"; "disabled": "disabled"; "elementAttr": "elementAttr"; "focusStateEnabled": "focusStateEnabled"; "formData": "formData"; "height": "height"; "hint": "hint"; "hoverStateEnabled": "hoverStateEnabled"; "isDirty": "isDirty"; "items": "items"; "labelLocation": "labelLocation"; "labelMode": "labelMode"; "minColWidth": "minColWidth"; "onContentReady": "onContentReady"; "onDisposing": "onDisposing"; "onEditorEnterKey": "onEditorEnterKey"; "onFieldDataChanged": "onFieldDataChanged"; "onInitialized": "onInitialized"; "onOptionChanged": "onOptionChanged"; "optionalMark": "optionalMark"; "readOnly": "readOnly"; "requiredMark": "requiredMark"; "requiredMessage": "requiredMessage"; "rtlEnabled": "rtlEnabled"; "screenByWidth": "screenByWidth"; "scrollingEnabled": "scrollingEnabled"; "showColonAfterLabel": "showColonAfterLabel"; "showOptionalMark": "showOptionalMark"; "showRequiredMark": "showRequiredMark"; "showValidationSummary": "showValidationSummary"; "tabIndex": "tabIndex"; "validationGroup": "validationGroup"; "visible": "visible"; "width": "width"; }, { "formDataChange": "formDataChange"; }, ["itemsChildren"], never>;
}
export declare class DxoFormModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoFormModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoFormModule, [typeof DxoFormComponent], never, [typeof DxoFormComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoFormModule>;
}
