/*!
 * devextreme-angular
 * Version: 23.2.6-build-24091-0113
 * Build date: Sun Mar 31 2024
 *
 * Copyright (c) 2012 - 2024 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { QueryList } from '@angular/core';
import DevExpress from 'devextreme/bundles/dx.all';
import { DiagramCommand, DiagramShapeCategory, DiagramShapeType, DiagramToolboxDisplayMode } from 'devextreme/ui/diagram';
import { NestedOptionHost } from 'devextreme-angular/core';
import { CollectionNestedOption } from 'devextreme-angular/core';
import { DxiCommandComponent } from './command-dxi';
import * as i0 from "@angular/core";
export declare class DxiGroupComponent extends CollectionNestedOption {
    get commands(): Array<DiagramCommand | DevExpress.ui.dxDiagramCustomCommand>;
    set commands(value: Array<DiagramCommand | DevExpress.ui.dxDiagramCustomCommand>);
    get title(): string;
    set title(value: string);
    get category(): DiagramShapeCategory | string;
    set category(value: DiagramShapeCategory | string);
    get displayMode(): DiagramToolboxDisplayMode;
    set displayMode(value: DiagramToolboxDisplayMode);
    get expanded(): boolean;
    set expanded(value: boolean);
    get shapes(): Array<DiagramShapeType | string>;
    set shapes(value: Array<DiagramShapeType | string>);
    protected get _optionPath(): string;
    get commandsChildren(): QueryList<DxiCommandComponent>;
    set commandsChildren(value: QueryList<DxiCommandComponent>);
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxiGroupComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxiGroupComponent, "dxi-group", never, { "commands": "commands"; "title": "title"; "category": "category"; "displayMode": "displayMode"; "expanded": "expanded"; "shapes": "shapes"; }, {}, ["commandsChildren"], never>;
}
export declare class DxiGroupModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxiGroupModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxiGroupModule, [typeof DxiGroupComponent], never, [typeof DxiGroupComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxiGroupModule>;
}
