/*!
 * devextreme-angular
 * Version: 23.2.6-build-24091-0113
 * Build date: Sun Mar 31 2024
 *
 * Copyright (c) 2012 - 2024 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { OnInit, OnDestroy } from '@angular/core';
import { GroupExpandMode } from 'devextreme/common/grids';
import { NestedOptionHost } from 'devextreme-angular/core';
import { NestedOption } from 'devextreme-angular/core';
import * as i0 from "@angular/core";
export declare class DxoGroupingComponent extends NestedOption implements OnDestroy, OnInit {
    get allowCollapsing(): boolean;
    set allowCollapsing(value: boolean);
    get autoExpandAll(): boolean;
    set autoExpandAll(value: boolean);
    get contextMenuEnabled(): boolean;
    set contextMenuEnabled(value: boolean);
    get expandMode(): GroupExpandMode;
    set expandMode(value: GroupExpandMode);
    get texts(): {
        groupByThisColumn?: string;
        groupContinuedMessage?: string;
        groupContinuesMessage?: string;
        ungroup?: string;
        ungroupAll?: string;
    };
    set texts(value: {
        groupByThisColumn?: string;
        groupContinuedMessage?: string;
        groupContinuesMessage?: string;
        ungroup?: string;
        ungroupAll?: string;
    });
    protected get _optionPath(): string;
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoGroupingComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoGroupingComponent, "dxo-grouping", never, { "allowCollapsing": "allowCollapsing"; "autoExpandAll": "autoExpandAll"; "contextMenuEnabled": "contextMenuEnabled"; "expandMode": "expandMode"; "texts": "texts"; }, {}, never, never>;
}
export declare class DxoGroupingModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoGroupingModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoGroupingModule, [typeof DxoGroupingComponent], never, [typeof DxoGroupingComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoGroupingModule>;
}
