/*!
 * devextreme-angular
 * Version: 23.2.6-build-24091-0113
 * Build date: Sun Mar 31 2024
 *
 * Copyright (c) 2012 - 2024 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { OnInit, OnDestroy, QueryList } from '@angular/core';
import { NestedOptionHost } from 'devextreme-angular/core';
import { DxoHtmlEditorImageUpload } from './base/html-editor-image-upload';
import { DxiTabComponent } from './tab-dxi';
import * as i0 from "@angular/core";
export declare class DxoImageUploadComponent extends DxoHtmlEditorImageUpload implements OnDestroy, OnInit {
    protected get _optionPath(): string;
    get tabsChildren(): QueryList<DxiTabComponent>;
    set tabsChildren(value: QueryList<DxiTabComponent>);
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoImageUploadComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoImageUploadComponent, "dxo-image-upload", never, { "fileUploaderOptions": "fileUploaderOptions"; "fileUploadMode": "fileUploadMode"; "tabs": "tabs"; "uploadDirectory": "uploadDirectory"; "uploadUrl": "uploadUrl"; }, {}, ["tabsChildren"], never>;
}
export declare class DxoImageUploadModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoImageUploadModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoImageUploadModule, [typeof DxoImageUploadComponent], never, [typeof DxoImageUploadComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoImageUploadModule>;
}
