/*!
 * devextreme-angular
 * Version: 23.2.6-build-24091-0113
 * Build date: Sun Mar 31 2024
 *
 * Copyright (c) 2012 - 2024 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { ElementRef, Renderer2, AfterViewInit, QueryList } from '@angular/core';
import { NestedOptionHost, DxTemplateDirective, IDxTemplateHost, DxTemplateHost } from 'devextreme-angular/core';
import { DxiButtonGroupItem } from './base/button-group-item-dxi';
import { DxiValidationRuleComponent } from './validation-rule-dxi';
import { DxiTabComponent } from './tab-dxi';
import { DxiLocationComponent } from './location-dxi';
import * as i0 from "@angular/core";
export declare class DxiItemComponent extends DxiButtonGroupItem implements AfterViewInit, IDxTemplateHost {
    private renderer;
    private document;
    private element;
    protected get _optionPath(): string;
    get itemsChildren(): QueryList<DxiItemComponent>;
    set itemsChildren(value: QueryList<DxiItemComponent>);
    get validationRulesChildren(): QueryList<DxiValidationRuleComponent>;
    set validationRulesChildren(value: QueryList<DxiValidationRuleComponent>);
    get tabsChildren(): QueryList<DxiTabComponent>;
    set tabsChildren(value: QueryList<DxiTabComponent>);
    get locationChildren(): QueryList<DxiLocationComponent>;
    set locationChildren(value: QueryList<DxiLocationComponent>);
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost, renderer: Renderer2, document: any, templateHost: DxTemplateHost, element: ElementRef);
    setTemplate(template: DxTemplateDirective): void;
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxiItemComponent, [{ host: true; skipSelf: true; }, { host: true; }, null, null, { host: true; }, null]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxiItemComponent, "dxi-item", never, { "disabled": "disabled"; "html": "html"; "icon": "icon"; "template": "template"; "text": "text"; "title": "title"; "titleTemplate": "titleTemplate"; "visible": "visible"; "onClick": "onClick"; "stylingMode": "stylingMode"; "type": "type"; "baseSize": "baseSize"; "box": "box"; "ratio": "ratio"; "shrink": "shrink"; "elementAttr": "elementAttr"; "hint": "hint"; "beginGroup": "beginGroup"; "closeMenuOnClick": "closeMenuOnClick"; "items": "items"; "selectable": "selectable"; "selected": "selected"; "colSpan": "colSpan"; "cssClass": "cssClass"; "dataField": "dataField"; "editorOptions": "editorOptions"; "editorType": "editorType"; "helpText": "helpText"; "isRequired": "isRequired"; "itemType": "itemType"; "label": "label"; "name": "name"; "validationRules": "validationRules"; "visibleIndex": "visibleIndex"; "alignItemLabels": "alignItemLabels"; "caption": "caption"; "colCount": "colCount"; "colCountByScreen": "colCountByScreen"; "tabPanelOptions": "tabPanelOptions"; "tabs": "tabs"; "badge": "badge"; "tabTemplate": "tabTemplate"; "buttonOptions": "buttonOptions"; "horizontalAlignment": "horizontalAlignment"; "verticalAlignment": "verticalAlignment"; "locateInMenu": "locateInMenu"; "location": "location"; "menuItemTemplate": "menuItemTemplate"; "options": "options"; "showText": "showText"; "widget": "widget"; "height": "height"; "width": "width"; "imageAlt": "imageAlt"; "imageSrc": "imageSrc"; "acceptedValues": "acceptedValues"; "formatName": "formatName"; "formatValues": "formatValues"; "key": "key"; "showChevron": "showChevron"; "linkAttr": "linkAttr"; "url": "url"; "heightRatio": "heightRatio"; "widthRatio": "widthRatio"; "expanded": "expanded"; "hasItems": "hasItems"; "id": "id"; "parentId": "parentId"; }, {}, ["itemsChildren", "validationRulesChildren", "tabsChildren", "locationChildren"], ["*"]>;
}
export declare class DxiItemModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxiItemModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxiItemModule, [typeof DxiItemComponent], never, [typeof DxiItemComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxiItemModule>;
}
