/*!
 * devextreme-angular
 * Version: 23.2.6-build-24091-0113
 * Build date: Sun Mar 31 2024
 *
 * Copyright (c) 2012 - 2024 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { OnInit, OnDestroy } from '@angular/core';
import DevExpress from 'devextreme/bundles/dx.all';
import { FileManagerItemViewMode } from 'devextreme/ui/file_manager';
import { NestedOptionHost } from 'devextreme-angular/core';
import { NestedOption } from 'devextreme-angular/core';
import * as i0 from "@angular/core";
export declare class DxoItemViewComponent extends NestedOption implements OnDestroy, OnInit {
    get details(): {
        columns?: Array<DevExpress.ui.dxFileManagerDetailsColumn | string>;
    };
    set details(value: {
        columns?: Array<DevExpress.ui.dxFileManagerDetailsColumn | string>;
    });
    get mode(): FileManagerItemViewMode;
    set mode(value: FileManagerItemViewMode);
    get showFolders(): boolean;
    set showFolders(value: boolean);
    get showParentFolder(): boolean;
    set showParentFolder(value: boolean);
    protected get _optionPath(): string;
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoItemViewComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoItemViewComponent, "dxo-item-view", never, { "details": "details"; "mode": "mode"; "showFolders": "showFolders"; "showParentFolder": "showParentFolder"; }, {}, never, never>;
}
export declare class DxoItemViewModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoItemViewModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoItemViewModule, [typeof DxoItemViewComponent], never, [typeof DxoItemViewComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoItemViewModule>;
}
