import { HorizontalAlignment, Orientation, Position, VerticalEdge } from 'devextreme/common';
import { DashStyle, Font } from 'devextreme/common/charts';
import { VectorMapMarkerShape } from 'devextreme/viz/vector_map';
import { NestedOptionHost } from 'devextreme-angular/core';
import { CollectionNestedOption } from 'devextreme-angular/core';
import * as i0 from "@angular/core";
export declare class DxiLegendComponent extends CollectionNestedOption {
    get backgroundColor(): string | undefined;
    set backgroundColor(value: string | undefined);
    get border(): {
        color?: string;
        cornerRadius?: number;
        dashStyle?: DashStyle;
        opacity?: number | undefined;
        visible?: boolean;
        width?: number;
    };
    set border(value: {
        color?: string;
        cornerRadius?: number;
        dashStyle?: DashStyle;
        opacity?: number | undefined;
        visible?: boolean;
        width?: number;
    });
    get columnCount(): number;
    set columnCount(value: number);
    get columnItemSpacing(): number;
    set columnItemSpacing(value: number);
    get customizeHint(): Function;
    set customizeHint(value: Function);
    get customizeItems(): Function;
    set customizeItems(value: Function);
    get customizeText(): Function;
    set customizeText(value: Function);
    get font(): Font;
    set font(value: Font);
    get horizontalAlignment(): HorizontalAlignment;
    set horizontalAlignment(value: HorizontalAlignment);
    get itemsAlignment(): HorizontalAlignment | undefined;
    set itemsAlignment(value: HorizontalAlignment | undefined);
    get itemTextPosition(): Position | undefined;
    set itemTextPosition(value: Position | undefined);
    get margin(): number | {
        bottom?: number;
        left?: number;
        right?: number;
        top?: number;
    };
    set margin(value: number | {
        bottom?: number;
        left?: number;
        right?: number;
        top?: number;
    });
    get markerColor(): string | undefined;
    set markerColor(value: string | undefined);
    get markerShape(): VectorMapMarkerShape;
    set markerShape(value: VectorMapMarkerShape);
    get markerSize(): number;
    set markerSize(value: number);
    get markerTemplate(): any | undefined;
    set markerTemplate(value: any | undefined);
    get orientation(): Orientation | undefined;
    set orientation(value: Orientation | undefined);
    get paddingLeftRight(): number;
    set paddingLeftRight(value: number);
    get paddingTopBottom(): number;
    set paddingTopBottom(value: number);
    get rowCount(): number;
    set rowCount(value: number);
    get rowItemSpacing(): number;
    set rowItemSpacing(value: number);
    get source(): {
        grouping?: string;
        layer?: string;
    };
    set source(value: {
        grouping?: string;
        layer?: string;
    });
    get title(): string | {
        font?: Font;
        horizontalAlignment?: HorizontalAlignment | undefined;
        margin?: {
            bottom?: number;
            left?: number;
            right?: number;
            top?: number;
        };
        placeholderSize?: number | undefined;
        subtitle?: string | {
            font?: Font;
            offset?: number;
            text?: string;
        };
        text?: string;
        verticalAlignment?: VerticalEdge;
    };
    set title(value: string | {
        font?: Font;
        horizontalAlignment?: HorizontalAlignment | undefined;
        margin?: {
            bottom?: number;
            left?: number;
            right?: number;
            top?: number;
        };
        placeholderSize?: number | undefined;
        subtitle?: string | {
            font?: Font;
            offset?: number;
            text?: string;
        };
        text?: string;
        verticalAlignment?: VerticalEdge;
    });
    get verticalAlignment(): VerticalEdge;
    set verticalAlignment(value: VerticalEdge);
    get visible(): boolean;
    set visible(value: boolean);
    protected get _optionPath(): string;
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxiLegendComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxiLegendComponent, "dxi-legend", never, { "backgroundColor": "backgroundColor"; "border": "border"; "columnCount": "columnCount"; "columnItemSpacing": "columnItemSpacing"; "customizeHint": "customizeHint"; "customizeItems": "customizeItems"; "customizeText": "customizeText"; "font": "font"; "horizontalAlignment": "horizontalAlignment"; "itemsAlignment": "itemsAlignment"; "itemTextPosition": "itemTextPosition"; "margin": "margin"; "markerColor": "markerColor"; "markerShape": "markerShape"; "markerSize": "markerSize"; "markerTemplate": "markerTemplate"; "orientation": "orientation"; "paddingLeftRight": "paddingLeftRight"; "paddingTopBottom": "paddingTopBottom"; "rowCount": "rowCount"; "rowItemSpacing": "rowItemSpacing"; "source": "source"; "title": "title"; "verticalAlignment": "verticalAlignment"; "visible": "visible"; }, {}, never, never>;
}
export declare class DxiLegendModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxiLegendModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxiLegendModule, [typeof DxiLegendComponent], never, [typeof DxiLegendComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxiLegendModule>;
}
