/*!
 * devextreme-angular
 * Version: 23.2.6-build-24091-0113
 * Build date: Sun Mar 31 2024
 *
 * Copyright (c) 2012 - 2024 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { OnInit, OnDestroy } from '@angular/core';
import { HorizontalAlignment, Orientation, Position, VerticalEdge } from 'devextreme/common';
import { DashStyle, Font, LegendHoverMode, RelativePosition } from 'devextreme/common/charts';
import { Format } from 'devextreme/localization';
import { PieChartLegendHoverMode } from 'devextreme/viz/pie_chart';
import { NestedOptionHost } from 'devextreme-angular/core';
import { NestedOption } from 'devextreme-angular/core';
import * as i0 from "@angular/core";
export declare class DxoLegendComponent extends NestedOption implements OnDestroy, OnInit {
    get backgroundColor(): string | undefined;
    set backgroundColor(value: string | undefined);
    get border(): {
        color?: string;
        cornerRadius?: number;
        dashStyle?: DashStyle;
        opacity?: number | undefined;
        visible?: boolean;
        width?: number;
    };
    set border(value: {
        color?: string;
        cornerRadius?: number;
        dashStyle?: DashStyle;
        opacity?: number | undefined;
        visible?: boolean;
        width?: number;
    });
    get columnCount(): number;
    set columnCount(value: number);
    get columnItemSpacing(): number;
    set columnItemSpacing(value: number);
    get customizeHint(): Function;
    set customizeHint(value: Function);
    get customizeItems(): Function;
    set customizeItems(value: Function);
    get customizeText(): Function;
    set customizeText(value: Function);
    get font(): Font;
    set font(value: Font);
    get horizontalAlignment(): HorizontalAlignment;
    set horizontalAlignment(value: HorizontalAlignment);
    get itemsAlignment(): HorizontalAlignment | undefined;
    set itemsAlignment(value: HorizontalAlignment | undefined);
    get itemTextFormat(): Format | string | undefined;
    set itemTextFormat(value: Format | string | undefined);
    get itemTextPosition(): Position | undefined;
    set itemTextPosition(value: Position | undefined);
    get margin(): number | {
        bottom?: number;
        left?: number;
        right?: number;
        top?: number;
    };
    set margin(value: number | {
        bottom?: number;
        left?: number;
        right?: number;
        top?: number;
    });
    get markerSize(): number;
    set markerSize(value: number);
    get markerTemplate(): any | undefined;
    set markerTemplate(value: any | undefined);
    get orientation(): Orientation | undefined;
    set orientation(value: Orientation | undefined);
    get paddingLeftRight(): number;
    set paddingLeftRight(value: number);
    get paddingTopBottom(): number;
    set paddingTopBottom(value: number);
    get rowCount(): number;
    set rowCount(value: number);
    get rowItemSpacing(): number;
    set rowItemSpacing(value: number);
    get title(): string | {
        font?: Font;
        horizontalAlignment?: HorizontalAlignment | undefined;
        margin?: {
            bottom?: number;
            left?: number;
            right?: number;
            top?: number;
        };
        placeholderSize?: number | undefined;
        subtitle?: string | {
            font?: Font;
            offset?: number;
            text?: string;
        };
        text?: string;
        verticalAlignment?: VerticalEdge;
    };
    set title(value: string | {
        font?: Font;
        horizontalAlignment?: HorizontalAlignment | undefined;
        margin?: {
            bottom?: number;
            left?: number;
            right?: number;
            top?: number;
        };
        placeholderSize?: number | undefined;
        subtitle?: string | {
            font?: Font;
            offset?: number;
            text?: string;
        };
        text?: string;
        verticalAlignment?: VerticalEdge;
    });
    get verticalAlignment(): VerticalEdge;
    set verticalAlignment(value: VerticalEdge);
    get visible(): boolean;
    set visible(value: boolean);
    get hoverMode(): LegendHoverMode | PieChartLegendHoverMode;
    set hoverMode(value: LegendHoverMode | PieChartLegendHoverMode);
    get position(): RelativePosition;
    set position(value: RelativePosition);
    protected get _optionPath(): string;
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoLegendComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoLegendComponent, "dxo-legend", never, { "backgroundColor": "backgroundColor"; "border": "border"; "columnCount": "columnCount"; "columnItemSpacing": "columnItemSpacing"; "customizeHint": "customizeHint"; "customizeItems": "customizeItems"; "customizeText": "customizeText"; "font": "font"; "horizontalAlignment": "horizontalAlignment"; "itemsAlignment": "itemsAlignment"; "itemTextFormat": "itemTextFormat"; "itemTextPosition": "itemTextPosition"; "margin": "margin"; "markerSize": "markerSize"; "markerTemplate": "markerTemplate"; "orientation": "orientation"; "paddingLeftRight": "paddingLeftRight"; "paddingTopBottom": "paddingTopBottom"; "rowCount": "rowCount"; "rowItemSpacing": "rowItemSpacing"; "title": "title"; "verticalAlignment": "verticalAlignment"; "visible": "visible"; "hoverMode": "hoverMode"; "position": "position"; }, {}, never, never>;
}
export declare class DxoLegendModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoLegendModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoLegendModule, [typeof DxoLegendComponent], never, [typeof DxoLegendComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoLegendModule>;
}
