/*!
 * devextreme-angular
 * Version: 23.2.6-build-24091-0113
 * Build date: Sun Mar 31 2024
 *
 * Copyright (c) 2012 - 2024 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { OnInit, OnDestroy } from '@angular/core';
import { HatchDirection } from 'devextreme/common/charts';
import { SankeyColorMode } from 'devextreme/viz/sankey';
import { NestedOptionHost } from 'devextreme-angular/core';
import { NestedOption } from 'devextreme-angular/core';
import * as i0 from "@angular/core";
export declare class DxoLinkComponent extends NestedOption implements OnDestroy, OnInit {
    get border(): {
        color?: string;
        visible?: boolean;
        width?: number;
    };
    set border(value: {
        color?: string;
        visible?: boolean;
        width?: number;
    });
    get color(): string;
    set color(value: string);
    get colorMode(): SankeyColorMode;
    set colorMode(value: SankeyColorMode);
    get hoverStyle(): {
        border?: {
            color?: string | undefined;
            visible?: boolean | undefined;
            width?: number | undefined;
        };
        color?: string | undefined;
        hatching?: {
            direction?: HatchDirection;
            opacity?: number;
            step?: number;
            width?: number;
        };
        opacity?: number;
    };
    set hoverStyle(value: {
        border?: {
            color?: string | undefined;
            visible?: boolean | undefined;
            width?: number | undefined;
        };
        color?: string | undefined;
        hatching?: {
            direction?: HatchDirection;
            opacity?: number;
            step?: number;
            width?: number;
        };
        opacity?: number;
    });
    get opacity(): number;
    set opacity(value: number);
    protected get _optionPath(): string;
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoLinkComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoLinkComponent, "dxo-link", never, { "border": "border"; "color": "color"; "colorMode": "colorMode"; "hoverStyle": "hoverStyle"; "opacity": "opacity"; }, {}, never, never>;
}
export declare class DxoLinkModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoLinkModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoLinkModule, [typeof DxoLinkComponent], never, [typeof DxoLinkComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoLinkModule>;
}
