/*!
 * devextreme-angular
 * Version: 23.2.6-build-24091-0113
 * Build date: Sun Mar 31 2024
 *
 * Copyright (c) 2012 - 2024 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { QueryList } from '@angular/core';
import { NestedOptionHost } from 'devextreme-angular/core';
import { CollectionNestedOption } from 'devextreme-angular/core';
import { DxiLocationComponent } from './location-dxi';
import * as i0 from "@angular/core";
export declare class DxiMarkerComponent extends CollectionNestedOption {
    get iconSrc(): string;
    set iconSrc(value: string);
    get location(): string | Array<number | {
        lat?: number;
        lng?: number;
    }>;
    set location(value: string | Array<number | {
        lat?: number;
        lng?: number;
    }>);
    get onClick(): Function;
    set onClick(value: Function);
    get tooltip(): string | {
        isShown?: boolean;
        text?: string;
    };
    set tooltip(value: string | {
        isShown?: boolean;
        text?: string;
    });
    protected get _optionPath(): string;
    get locationChildren(): QueryList<DxiLocationComponent>;
    set locationChildren(value: QueryList<DxiLocationComponent>);
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxiMarkerComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxiMarkerComponent, "dxi-marker", never, { "iconSrc": "iconSrc"; "location": "location"; "onClick": "onClick"; "tooltip": "tooltip"; }, {}, ["locationChildren"], never>;
}
export declare class DxiMarkerModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxiMarkerModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxiMarkerModule, [typeof DxiMarkerComponent], never, [typeof DxiMarkerComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxiMarkerModule>;
}
