/*!
 * devextreme-angular
 * Version: 23.2.6-build-24091-0113
 * Build date: Sun Mar 31 2024
 *
 * Copyright (c) 2012 - 2024 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { OnInit, OnDestroy } from '@angular/core';
import { HatchDirection } from 'devextreme/common/charts';
import { NestedOptionHost } from 'devextreme-angular/core';
import { NestedOption } from 'devextreme-angular/core';
import * as i0 from "@angular/core";
export declare class DxoNodeComponent extends NestedOption implements OnDestroy, OnInit {
    get border(): {
        color?: string;
        visible?: boolean;
        width?: number;
    };
    set border(value: {
        color?: string;
        visible?: boolean;
        width?: number;
    });
    get color(): string | undefined;
    set color(value: string | undefined);
    get hoverStyle(): {
        border?: {
            color?: string | undefined;
            visible?: boolean | undefined;
            width?: number | undefined;
        };
        color?: string | undefined;
        hatching?: {
            direction?: HatchDirection;
            opacity?: number;
            step?: number;
            width?: number;
        };
        opacity?: number | undefined;
    };
    set hoverStyle(value: {
        border?: {
            color?: string | undefined;
            visible?: boolean | undefined;
            width?: number | undefined;
        };
        color?: string | undefined;
        hatching?: {
            direction?: HatchDirection;
            opacity?: number;
            step?: number;
            width?: number;
        };
        opacity?: number | undefined;
    });
    get opacity(): number;
    set opacity(value: number);
    get padding(): number;
    set padding(value: number);
    get width(): number;
    set width(value: number);
    protected get _optionPath(): string;
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoNodeComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoNodeComponent, "dxo-node", never, { "border": "border"; "color": "color"; "hoverStyle": "hoverStyle"; "opacity": "opacity"; "padding": "padding"; "width": "width"; }, {}, never, never>;
}
export declare class DxoNodeModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoNodeModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoNodeModule, [typeof DxoNodeComponent], never, [typeof DxoNodeComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoNodeModule>;
}
