/*!
 * devextreme-angular
 * Version: 23.2.6-build-24091-0113
 * Build date: Sun Mar 31 2024
 *
 * Copyright (c) 2012 - 2024 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { OnInit, OnDestroy } from '@angular/core';
import { Mode } from 'devextreme/common';
import { PagerDisplayMode, PagerPageSize } from 'devextreme/common/grids';
import { NestedOptionHost } from 'devextreme-angular/core';
import { NestedOption } from 'devextreme-angular/core';
import * as i0 from "@angular/core";
export declare class DxoPagerComponent extends NestedOption implements OnDestroy, OnInit {
    get allowedPageSizes(): Mode | Array<PagerPageSize | number>;
    set allowedPageSizes(value: Mode | Array<PagerPageSize | number>);
    get displayMode(): PagerDisplayMode;
    set displayMode(value: PagerDisplayMode);
    get infoText(): string;
    set infoText(value: string);
    get label(): string;
    set label(value: string);
    get showInfo(): boolean;
    set showInfo(value: boolean);
    get showNavigationButtons(): boolean;
    set showNavigationButtons(value: boolean);
    get showPageSizeSelector(): boolean;
    set showPageSizeSelector(value: boolean);
    get visible(): Mode | boolean;
    set visible(value: Mode | boolean);
    protected get _optionPath(): string;
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoPagerComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoPagerComponent, "dxo-pager", never, { "allowedPageSizes": "allowedPageSizes"; "displayMode": "displayMode"; "infoText": "infoText"; "label": "label"; "showInfo": "showInfo"; "showNavigationButtons": "showNavigationButtons"; "showPageSizeSelector": "showPageSizeSelector"; "visible": "visible"; }, {}, never, never>;
}
export declare class DxoPagerModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoPagerModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoPagerModule, [typeof DxoPagerComponent], never, [typeof DxoPagerComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoPagerModule>;
}
