/*!
 * devextreme-angular
 * Version: 23.2.6-build-24091-0113
 * Build date: Sun Mar 31 2024
 *
 * Copyright (c) 2012 - 2024 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { OnInit, OnDestroy, QueryList } from '@angular/core';
import DevExpress from 'devextreme/bundles/dx.all';
import { HorizontalAlignment, VerticalAlignment } from 'devextreme/common';
import { Palette, PaletteExtensionMode } from 'devextreme/common/charts';
import { CircularGaugeElementOrientation } from 'devextreme/viz/circular_gauge';
import { NestedOptionHost } from 'devextreme-angular/core';
import { NestedOption } from 'devextreme-angular/core';
import { DxiRangeComponent } from './range-dxi';
import * as i0 from "@angular/core";
export declare class DxoRangeContainerComponent extends NestedOption implements OnDestroy, OnInit {
    get backgroundColor(): DevExpress.common.charts.ChartsColor | string;
    set backgroundColor(value: DevExpress.common.charts.ChartsColor | string);
    get offset(): number;
    set offset(value: number);
    get orientation(): CircularGaugeElementOrientation;
    set orientation(value: CircularGaugeElementOrientation);
    get palette(): Palette | string | Array<string>;
    set palette(value: Palette | string | Array<string>);
    get paletteExtensionMode(): PaletteExtensionMode;
    set paletteExtensionMode(value: PaletteExtensionMode);
    get ranges(): Array<any | {
        color?: DevExpress.common.charts.ChartsColor | string;
        endValue?: number;
        startValue?: number;
    }>;
    set ranges(value: Array<any | {
        color?: DevExpress.common.charts.ChartsColor | string;
        endValue?: number;
        startValue?: number;
    }>);
    get width(): number | {
        end?: number;
        start?: number;
    };
    set width(value: number | {
        end?: number;
        start?: number;
    });
    get horizontalOrientation(): HorizontalAlignment;
    set horizontalOrientation(value: HorizontalAlignment);
    get verticalOrientation(): VerticalAlignment;
    set verticalOrientation(value: VerticalAlignment);
    protected get _optionPath(): string;
    get rangesChildren(): QueryList<DxiRangeComponent>;
    set rangesChildren(value: QueryList<DxiRangeComponent>);
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoRangeContainerComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoRangeContainerComponent, "dxo-range-container", never, { "backgroundColor": "backgroundColor"; "offset": "offset"; "orientation": "orientation"; "palette": "palette"; "paletteExtensionMode": "paletteExtensionMode"; "ranges": "ranges"; "width": "width"; "horizontalOrientation": "horizontalOrientation"; "verticalOrientation": "verticalOrientation"; }, {}, ["rangesChildren"], never>;
}
export declare class DxoRangeContainerModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoRangeContainerModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoRangeContainerModule, [typeof DxoRangeContainerComponent], never, [typeof DxoRangeContainerComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoRangeContainerModule>;
}
