/*!
 * devextreme-angular
 * Version: 23.2.6-build-24091-0113
 * Build date: Sun Mar 31 2024
 *
 * Copyright (c) 2012 - 2024 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { OnInit, OnDestroy } from '@angular/core';
import { Font } from 'devextreme/common/charts';
import { Format } from 'devextreme/localization';
import { NestedOptionHost } from 'devextreme-angular/core';
import { NestedOption } from 'devextreme-angular/core';
import * as i0 from "@angular/core";
export declare class DxoSliderMarkerComponent extends NestedOption implements OnDestroy, OnInit {
    get color(): string;
    set color(value: string);
    get customizeText(): Function;
    set customizeText(value: Function);
    get font(): Font;
    set font(value: Font);
    get format(): Format | string | undefined;
    set format(value: Format | string | undefined);
    get invalidRangeColor(): string;
    set invalidRangeColor(value: string);
    get paddingLeftRight(): number;
    set paddingLeftRight(value: number);
    get paddingTopBottom(): number;
    set paddingTopBottom(value: number);
    get placeholderHeight(): number | undefined;
    set placeholderHeight(value: number | undefined);
    get visible(): boolean;
    set visible(value: boolean);
    protected get _optionPath(): string;
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoSliderMarkerComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoSliderMarkerComponent, "dxo-slider-marker", never, { "color": "color"; "customizeText": "customizeText"; "font": "font"; "format": "format"; "invalidRangeColor": "invalidRangeColor"; "paddingLeftRight": "paddingLeftRight"; "paddingTopBottom": "paddingTopBottom"; "placeholderHeight": "placeholderHeight"; "visible": "visible"; }, {}, never, never>;
}
export declare class DxoSliderMarkerModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoSliderMarkerModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoSliderMarkerModule, [typeof DxoSliderMarkerComponent], never, [typeof DxoSliderMarkerComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoSliderMarkerModule>;
}
