/*!
 * devextreme-angular
 * Version: 23.2.6-build-24091-0113
 * Build date: Sun Mar 31 2024
 *
 * Copyright (c) 2012 - 2024 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { OnInit, OnDestroy } from '@angular/core';
import { NestedOptionHost } from 'devextreme-angular/core';
import { DxoChartCommonSeriesSettings } from './base/chart-common-series-settings';
import * as i0 from "@angular/core";
export declare class DxoSteplineComponent extends DxoChartCommonSeriesSettings implements OnDestroy, OnInit {
    protected get _optionPath(): string;
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoSteplineComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoSteplineComponent, "dxo-stepline", never, { "aggregation": "aggregation"; "area": "area"; "argumentField": "argumentField"; "axis": "axis"; "bar": "bar"; "barOverlapGroup": "barOverlapGroup"; "barPadding": "barPadding"; "barWidth": "barWidth"; "border": "border"; "bubble": "bubble"; "candlestick": "candlestick"; "closeValueField": "closeValueField"; "color": "color"; "cornerRadius": "cornerRadius"; "dashStyle": "dashStyle"; "fullstackedarea": "fullstackedarea"; "fullstackedbar": "fullstackedbar"; "fullstackedline": "fullstackedline"; "fullstackedspline": "fullstackedspline"; "fullstackedsplinearea": "fullstackedsplinearea"; "highValueField": "highValueField"; "hoverMode": "hoverMode"; "hoverStyle": "hoverStyle"; "ignoreEmptyPoints": "ignoreEmptyPoints"; "innerColor": "innerColor"; "label": "label"; "line": "line"; "lowValueField": "lowValueField"; "maxLabelCount": "maxLabelCount"; "minBarSize": "minBarSize"; "opacity": "opacity"; "openValueField": "openValueField"; "pane": "pane"; "point": "point"; "rangearea": "rangearea"; "rangebar": "rangebar"; "rangeValue1Field": "rangeValue1Field"; "rangeValue2Field": "rangeValue2Field"; "reduction": "reduction"; "scatter": "scatter"; "selectionMode": "selectionMode"; "selectionStyle": "selectionStyle"; "showInLegend": "showInLegend"; "sizeField": "sizeField"; "spline": "spline"; "splinearea": "splinearea"; "stack": "stack"; "stackedarea": "stackedarea"; "stackedbar": "stackedbar"; "stackedline": "stackedline"; "stackedspline": "stackedspline"; "stackedsplinearea": "stackedsplinearea"; "steparea": "steparea"; "stepline": "stepline"; "stock": "stock"; "tagField": "tagField"; "type": "type"; "valueErrorBar": "valueErrorBar"; "valueField": "valueField"; "visible": "visible"; "width": "width"; }, {}, never, never>;
}
export declare class DxoSteplineModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoSteplineModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoSteplineModule, [typeof DxoSteplineComponent], never, [typeof DxoSteplineComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoSteplineModule>;
}
