/*!
 * devextreme-angular
 * Version: 23.2.6-build-24091-0113
 * Build date: Sun Mar 31 2024
 *
 * Copyright (c) 2012 - 2024 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { OnInit, OnDestroy, QueryList } from '@angular/core';
import { HorizontalAlignment } from 'devextreme/common';
import { SummaryType } from 'devextreme/common/grids';
import { Format } from 'devextreme/localization';
import { NestedOptionHost } from 'devextreme-angular/core';
import { NestedOption } from 'devextreme-angular/core';
import { DxiGroupItemComponent } from './group-item-dxi';
import { DxiTotalItemComponent } from './total-item-dxi';
import * as i0 from "@angular/core";
export declare class DxoSummaryComponent extends NestedOption implements OnDestroy, OnInit {
    get calculateCustomSummary(): Function;
    set calculateCustomSummary(value: Function);
    get groupItems(): Array<any | {
        alignByColumn?: boolean;
        column?: string | undefined;
        customizeText?: Function;
        displayFormat?: string | undefined;
        name?: string | undefined;
        showInColumn?: string | undefined;
        showInGroupFooter?: boolean;
        skipEmptyValues?: boolean;
        summaryType?: SummaryType | string | undefined;
        valueFormat?: Format | string | undefined;
    }>;
    set groupItems(value: Array<any | {
        alignByColumn?: boolean;
        column?: string | undefined;
        customizeText?: Function;
        displayFormat?: string | undefined;
        name?: string | undefined;
        showInColumn?: string | undefined;
        showInGroupFooter?: boolean;
        skipEmptyValues?: boolean;
        summaryType?: SummaryType | string | undefined;
        valueFormat?: Format | string | undefined;
    }>);
    get recalculateWhileEditing(): boolean;
    set recalculateWhileEditing(value: boolean);
    get skipEmptyValues(): boolean;
    set skipEmptyValues(value: boolean);
    get texts(): {
        avg?: string;
        avgOtherColumn?: string;
        count?: string;
        max?: string;
        maxOtherColumn?: string;
        min?: string;
        minOtherColumn?: string;
        sum?: string;
        sumOtherColumn?: string;
    };
    set texts(value: {
        avg?: string;
        avgOtherColumn?: string;
        count?: string;
        max?: string;
        maxOtherColumn?: string;
        min?: string;
        minOtherColumn?: string;
        sum?: string;
        sumOtherColumn?: string;
    });
    get totalItems(): Array<any | {
        alignment?: HorizontalAlignment | undefined;
        column?: string | undefined;
        cssClass?: string | undefined;
        customizeText?: Function;
        displayFormat?: string | undefined;
        name?: string | undefined;
        showInColumn?: string | undefined;
        skipEmptyValues?: boolean;
        summaryType?: SummaryType | string | undefined;
        valueFormat?: Format | string | undefined;
    }>;
    set totalItems(value: Array<any | {
        alignment?: HorizontalAlignment | undefined;
        column?: string | undefined;
        cssClass?: string | undefined;
        customizeText?: Function;
        displayFormat?: string | undefined;
        name?: string | undefined;
        showInColumn?: string | undefined;
        skipEmptyValues?: boolean;
        summaryType?: SummaryType | string | undefined;
        valueFormat?: Format | string | undefined;
    }>);
    protected get _optionPath(): string;
    get groupItemsChildren(): QueryList<DxiGroupItemComponent>;
    set groupItemsChildren(value: QueryList<DxiGroupItemComponent>);
    get totalItemsChildren(): QueryList<DxiTotalItemComponent>;
    set totalItemsChildren(value: QueryList<DxiTotalItemComponent>);
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoSummaryComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoSummaryComponent, "dxo-summary", never, { "calculateCustomSummary": "calculateCustomSummary"; "groupItems": "groupItems"; "recalculateWhileEditing": "recalculateWhileEditing"; "skipEmptyValues": "skipEmptyValues"; "texts": "texts"; "totalItems": "totalItems"; }, {}, ["groupItemsChildren", "totalItemsChildren"], never>;
}
export declare class DxoSummaryModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoSummaryModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoSummaryModule, [typeof DxoSummaryComponent], never, [typeof DxoSummaryComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoSummaryModule>;
}
