/*!
 * devextreme-angular
 * Version: 23.2.6-build-24091-0113
 * Build date: Sun Mar 31 2024
 *
 * Copyright (c) 2012 - 2024 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { OnInit, OnDestroy } from '@angular/core';
import { Font } from 'devextreme/common/charts';
import { Format } from 'devextreme/localization';
import { NestedOptionHost } from 'devextreme-angular/core';
import { NestedOption } from 'devextreme-angular/core';
import * as i0 from "@angular/core";
export declare class DxoTextComponent extends NestedOption implements OnDestroy, OnInit {
    get customizeText(): Function | undefined;
    set customizeText(value: Function | undefined);
    get font(): Font;
    set font(value: Font);
    get format(): Format | string | undefined;
    set format(value: Format | string | undefined);
    get indent(): number;
    set indent(value: number);
    protected get _optionPath(): string;
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoTextComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoTextComponent, "dxo-text", never, { "customizeText": "customizeText"; "font": "font"; "format": "format"; "indent": "indent"; }, {}, never, never>;
}
export declare class DxoTextModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoTextModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoTextModule, [typeof DxoTextComponent], never, [typeof DxoTextComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoTextModule>;
}
