/*!
 * devextreme-angular
 * Version: 23.2.6-build-24091-0113
 * Build date: Sun Mar 31 2024
 *
 * Copyright (c) 2012 - 2024 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { OnInit, OnDestroy } from '@angular/core';
import { Font, TextOverflow, WordWrap } from 'devextreme/common/charts';
import { NestedOptionHost } from 'devextreme-angular/core';
import { NestedOption } from 'devextreme-angular/core';
import * as i0 from "@angular/core";
export declare class DxoTileComponent extends NestedOption implements OnDestroy, OnInit {
    get border(): {
        color?: string;
        width?: number;
    };
    set border(value: {
        color?: string;
        width?: number;
    });
    get color(): string;
    set color(value: string);
    get hoverStyle(): {
        border?: {
            color?: string | undefined;
            width?: number | undefined;
        };
        color?: string | undefined;
    };
    set hoverStyle(value: {
        border?: {
            color?: string | undefined;
            width?: number | undefined;
        };
        color?: string | undefined;
    });
    get label(): {
        font?: Font;
        textOverflow?: TextOverflow;
        visible?: boolean;
        wordWrap?: WordWrap;
    };
    set label(value: {
        font?: Font;
        textOverflow?: TextOverflow;
        visible?: boolean;
        wordWrap?: WordWrap;
    });
    get selectionStyle(): {
        border?: {
            color?: string;
            width?: number | undefined;
        };
        color?: string | undefined;
    };
    set selectionStyle(value: {
        border?: {
            color?: string;
            width?: number | undefined;
        };
        color?: string | undefined;
    });
    protected get _optionPath(): string;
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoTileComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoTileComponent, "dxo-tile", never, { "border": "border"; "color": "color"; "hoverStyle": "hoverStyle"; "label": "label"; "selectionStyle": "selectionStyle"; }, {}, never, never>;
}
export declare class DxoTileModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoTileModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoTileModule, [typeof DxoTileComponent], never, [typeof DxoTileComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoTileModule>;
}
