/*!
 * devextreme-angular
 * Version: 23.2.6-build-24091-0113
 * Build date: Sun Mar 31 2024
 *
 * Copyright (c) 2012 - 2024 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { OnInit, OnDestroy, QueryList } from '@angular/core';
import { DiagramPanelVisibility, DiagramShapeCategory, DiagramShapeType, DiagramToolboxDisplayMode } from 'devextreme/ui/diagram';
import { NestedOptionHost } from 'devextreme-angular/core';
import { NestedOption } from 'devextreme-angular/core';
import { DxiGroupComponent } from './group-dxi';
import * as i0 from "@angular/core";
export declare class DxoToolboxComponent extends NestedOption implements OnDestroy, OnInit {
    get groups(): Array<DiagramShapeCategory | any | {
        category?: DiagramShapeCategory | string;
        displayMode?: DiagramToolboxDisplayMode;
        expanded?: boolean;
        shapes?: Array<DiagramShapeType | string>;
        title?: string;
    }>;
    set groups(value: Array<DiagramShapeCategory | any | {
        category?: DiagramShapeCategory | string;
        displayMode?: DiagramToolboxDisplayMode;
        expanded?: boolean;
        shapes?: Array<DiagramShapeType | string>;
        title?: string;
    }>);
    get shapeIconsPerRow(): number;
    set shapeIconsPerRow(value: number);
    get showSearch(): boolean;
    set showSearch(value: boolean);
    get visibility(): DiagramPanelVisibility;
    set visibility(value: DiagramPanelVisibility);
    get width(): number | undefined;
    set width(value: number | undefined);
    protected get _optionPath(): string;
    get groupsChildren(): QueryList<DxiGroupComponent>;
    set groupsChildren(value: QueryList<DxiGroupComponent>);
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoToolboxComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoToolboxComponent, "dxo-toolbox", never, { "groups": "groups"; "shapeIconsPerRow": "shapeIconsPerRow"; "showSearch": "showSearch"; "visibility": "visibility"; "width": "width"; }, {}, ["groupsChildren"], never>;
}
export declare class DxoToolboxModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoToolboxModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoToolboxModule, [typeof DxoToolboxComponent], never, [typeof DxoToolboxComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoToolboxModule>;
}
