/*!
 * devextreme-angular
 * Version: 23.2.6-build-24091-0113
 * Build date: Sun Mar 31 2024
 *
 * Copyright (c) 2012 - 2024 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { OnInit, OnDestroy } from '@angular/core';
import { ValueErrorBarDisplayMode, ValueErrorBarType } from 'devextreme/common/charts';
import { NestedOptionHost } from 'devextreme-angular/core';
import { NestedOption } from 'devextreme-angular/core';
import * as i0 from "@angular/core";
export declare class DxoValueErrorBarComponent extends NestedOption implements OnDestroy, OnInit {
    get color(): string;
    set color(value: string);
    get displayMode(): ValueErrorBarDisplayMode;
    set displayMode(value: ValueErrorBarDisplayMode);
    get edgeLength(): number;
    set edgeLength(value: number);
    get highValueField(): string | undefined;
    set highValueField(value: string | undefined);
    get lineWidth(): number;
    set lineWidth(value: number);
    get lowValueField(): string | undefined;
    set lowValueField(value: string | undefined);
    get opacity(): number | undefined;
    set opacity(value: number | undefined);
    get type(): ValueErrorBarType | undefined;
    set type(value: ValueErrorBarType | undefined);
    get value(): number;
    set value(value: number);
    protected get _optionPath(): string;
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoValueErrorBarComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoValueErrorBarComponent, "dxo-value-error-bar", never, { "color": "color"; "displayMode": "displayMode"; "edgeLength": "edgeLength"; "highValueField": "highValueField"; "lineWidth": "lineWidth"; "lowValueField": "lowValueField"; "opacity": "opacity"; "type": "type"; "value": "value"; }, {}, never, never>;
}
export declare class DxoValueErrorBarModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoValueErrorBarModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoValueErrorBarModule, [typeof DxoValueErrorBarComponent], never, [typeof DxoValueErrorBarComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoValueErrorBarModule>;
}
