/*!
 * devextreme-angular
 * Version: 23.2.6-build-24091-0113
 * Build date: Sun Mar 31 2024
 *
 * Copyright (c) 2012 - 2024 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { OnInit, OnDestroy } from '@angular/core';
import { DashStyle, Font } from 'devextreme/common/charts';
import { Format } from 'devextreme/localization';
import { NestedOptionHost } from 'devextreme-angular/core';
import { NestedOption } from 'devextreme-angular/core';
import * as i0 from "@angular/core";
export declare class DxoVerticalLineComponent extends NestedOption implements OnDestroy, OnInit {
    get color(): string;
    set color(value: string);
    get dashStyle(): DashStyle;
    set dashStyle(value: DashStyle);
    get label(): {
        backgroundColor?: string;
        customizeText?: Function;
        font?: Font;
        format?: Format | string | undefined;
        visible?: boolean;
    };
    set label(value: {
        backgroundColor?: string;
        customizeText?: Function;
        font?: Font;
        format?: Format | string | undefined;
        visible?: boolean;
    });
    get opacity(): number | undefined;
    set opacity(value: number | undefined);
    get visible(): boolean;
    set visible(value: boolean);
    get width(): number;
    set width(value: number);
    protected get _optionPath(): string;
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoVerticalLineComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoVerticalLineComponent, "dxo-vertical-line", never, { "color": "color"; "dashStyle": "dashStyle"; "label": "label"; "opacity": "opacity"; "visible": "visible"; "width": "width"; }, {}, never, never>;
}
export declare class DxoVerticalLineModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoVerticalLineModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoVerticalLineModule, [typeof DxoVerticalLineComponent], never, [typeof DxoVerticalLineComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoVerticalLineModule>;
}
