/*!
 * devextreme-angular
 * Version: 23.2.6-build-24091-0113
 * Build date: Sun Mar 31 2024
 *
 * Copyright (c) 2012 - 2024 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { OnInit, OnDestroy, QueryList } from '@angular/core';
import DevExpress from 'devextreme/bundles/dx.all';
import { DiagramCommand } from 'devextreme/ui/diagram';
import { NestedOptionHost } from 'devextreme-angular/core';
import { NestedOption } from 'devextreme-angular/core';
import { DxiCommandComponent } from './command-dxi';
import * as i0 from "@angular/core";
export declare class DxoViewToolbarComponent extends NestedOption implements OnDestroy, OnInit {
    get commands(): Array<DiagramCommand | DevExpress.ui.dxDiagramCustomCommand>;
    set commands(value: Array<DiagramCommand | DevExpress.ui.dxDiagramCustomCommand>);
    get visible(): boolean;
    set visible(value: boolean);
    protected get _optionPath(): string;
    get commandsChildren(): QueryList<DxiCommandComponent>;
    set commandsChildren(value: QueryList<DxiCommandComponent>);
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoViewToolbarComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoViewToolbarComponent, "dxo-view-toolbar", never, { "commands": "commands"; "visible": "visible"; }, {}, ["commandsChildren"], never>;
}
export declare class DxoViewToolbarModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoViewToolbarModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoViewToolbarModule, [typeof DxoViewToolbarComponent], never, [typeof DxoViewToolbarComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoViewToolbarModule>;
}
